;##################################################################
; GoP
;##################################################################

#DEFINE WINVER NTDDI_WINXP

#include "GoP.h"

/*
DEBUGLIB equ \Programming\RadASM\GoAsm\lib\Debug.lib
DEBUGEXE equ "\Programming\RadAsm\GoAsm\lib\dbgwin.exe"

#include "\Programming\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 // use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists 
*/

IDD_DLG1	equ		1000

ExceptionArgs STRUCT
	Name	CHAR 28 DUP
	type	DWORD32
ENDS

PROFILE_ITEM STRUCT
	idItem		DD
	StartTick	DQ
	EndTick		DQ
	Address		PTR
	Name		CHAR	256 DUP ?
ENDS

#DEFINE EXCEPTION_STARTPROFILE	0x8F000001
#DEFINE EXCEPTION_ENDPROFILE	0x8F000002
#DEFINE EXCEPTION_QUITPROFILE	0x8F000003

DATA SECTION
	hInstance			HANDLE		?
	hDlg				HANDLE		?
	SessionId			HANDLE		?
	pCmdLn				PTR			?
	fActive				BOOL		0
	TimeOut				DWORD32		300000
	fTiming				BOOL		0
	ProfileName			CHAR		256	DUP ?
	hProfArray			HANDLE		0
	hTimingListView		HANDLE		?
	hDllListView		HANDLE		?
	hTab				HANDLE		?
	hTab1				HANDLE		?
	hTab2				HANDLE		?
	tid					DWORD32		?
	DllName				CHAR		MAX_PATH DUP ?
	hDebugThread		HANDLE		?

	ProfileTitle		CHAR		MAX_PATH DUP ?

	lvProfileName		CHAR		"Profile Name",0
	lvProfileStart		CHAR		"Start tick",0
	lvStartEIP			CHAR		"Start EIP",0
	lvProfileEnd		CHAR		"End tick",0
	lvEndEIP			CHAR		"End EIP",0
	lvProfileDiff		CHAR		"Difference",0

	fni					FILE_NAME_INFO	<0>
	DllPath				WCHAR		MAX_PATH DUP 0

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke GetCommandLine
	mov [pCmdLn],eax
	invoke InitCommonControls
	/*
		We will use a Dynamic Pointer Array from Common Controls to
		track the current profile. All profiles will be inserted at
		position 0 using a PROFILE_ITEM structure that contains the
		necessary information. When a profile is stopped its pointer
		is removed from the array. This acts as a stack in that the
		top of the array (position 0) is always a pointer to the next
		profile to close. It will allow for nested profiles:
		Profile(TopOfLoop)
			Profile(InnerLoop)
				Profile(SecondInnerLoop)
				EndProfile
				Profile(SomeOtherThing)
				EndProfile
			EndProfile
		EndProfile
	*/

	invoke DPA_Create,64
	mov [hProfArray],eax
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke DPA_DestroyCallback,[hProfArray],offset FreeAll, NULL
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL tci:TCITEM

	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_NOTIFY
		mov eax,[hwnd]
		mov [hDlg],eax

		invoke GetDlgItem,[hwnd],1001
		mov [hTab],eax

		mov D[tci.mask],TCIF_TEXT
		push "Timing"
		pop [tci.pszText]
		mov D[tci.iImage],0
		invoke SendMessage,[hTab],TCM_INSERTITEM,0,offset tci
		
		mov D[tci.mask],TCIF_TEXT
		push "DLL's loaded"
		pop [tci.pszText]
		mov D[tci.iImage],0
		invoke SendMessage,[hTab],TCM_INSERTITEM,1,offset tci

		invoke CreateDialogParam,[hInstance],IDD_TIMING,[hTab],addr DefaultProc,0
		mov [hTab1],eax
		invoke ShowWindow,[hTab1],SW_HIDE
		
		invoke GetDlgItem,[hTab1],1001
		mov [hTimingListView],eax
		invoke SetupTimingListView
		
		invoke CreateDialogParam,[hInstance],IDD_DLL,[hTab],addr DefaultProc,0
		mov [hTab2],eax
		invoke ShowWindow,[hTab2],SW_HIDE
		
		invoke GetDlgItem,[hTab2],1001
		mov [hDllListView],eax
		invoke SetupDllListView

		// Show the first tab keep the others hidden
		invoke SetWindowPos,[hTab1],NULL,10,30,NULL,NULL,SWP_NOSIZE + SWP_NOZORDER + SWP_SHOWWINDOW
		invoke SetWindowPos,[hTab2],NULL,10,30,NULL,NULL,SWP_NOSIZE + SWP_NOZORDER
		jmp >>.EXIT

	.WM_NOTIFY
	cmp D[uMsg],WM_NOTIFY
	jne >>.WM_COMMAND
		// If the user puts the address bar on a different rebar row
		// send a WM_SIZE message to notify the dialog that the
		// child controls need resizing
		mov edi,[lParam]

		.TCN_SELCHANGE
		cmp D[edi+NMHDR.code],TCN_SELCHANGE
		jnz >>.DEFPROC
			// If a tab is selected display the appropriate information
			invoke SendMessage,[hTab],TCM_GETCURSEL,0,0
			cmp eax,0
			jne >>.SELECTDLL
				// Show the timing tab
				invoke ShowWindow,[hTab1],SW_SHOW
				invoke ShowWindow,[hTab2],SW_HIDE
				mov eax,TRUE
				ret

			.SELECTDLL
			cmp eax,1
			jne >>.DEFPROC
				// Show the dll tab
				invoke ShowWindow,[hTab1],SW_HIDE
				invoke ShowWindow,[hTab2],SW_SHOW
				mov eax,TRUE
				ret

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_CLOSE
		movzx edx,W[wParam]
		cmp edx,1002
		jne >>.EXIT
			invoke CreateThread,NULL,NULL,offset DebugEventThread,"TestProfile\TestProfile.exe",NULL,offset tid
		jmp >.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

DefaultProc FRAME hwnd,uMsg,wParam,lParam
	;invoke DefDlgProc, [hwnd],[uMsg],[wParam],[lParam]
	mov eax,FALSE
	RET
ENDF

DebugEventThread FRAME lpParameter
	LOCAL dbe		:DEBUG_EVENT
	LOCAL sui		:STARTUPINFO
	LOCAL pi		:PROCESS_INFORMATION
	LOCAL cbWritten	:%DWORD32
	LOCAL context	:CONTEXT
	LOCAL pProfileInfo	:%PTR
	LOCAL ProfileType	:%DWORD32

	/*
		This thread must create the process to be debugged
		According to MSDN docs:
		"Only the thread that created the process being debugged can call WaitForDebugEvent."
	*/

	invoke CreateProcess,NULL,[lpParameter],NULL,NULL,\
					TRUE,DEBUG_ONLY_THIS_PROCESS,NULL,NULL,OFFSET sui,OFFSET pi

	test eax,eax
	jz >>.EXITTHREAD

	invoke lstrcpy,offset ProfileTitle,"GoP - Profiling "
	invoke PathFindFileName,[lpParameter]
	invoke lstrcat,offset ProfileTitle,eax

	invoke SendMessage,[hDlg],WM_SETTEXT,0,offset ProfileTitle

	/*
		This will ensure that the profilee will be terminated when the thread exits
		Requires Windows XP or greater
	*/

	invoke DebugSetProcessKillOnExit, TRUE

	/*
		Wait until Windows signals that a debug event has occured. We will set a maximum
		wait time of 5 minutes (default) at which point we will prompt the user to stop the
		debug or continue
	*/

	.WAIT_FOR_EVENT
	invoke WaitForDebugEvent,offset dbe,[TimeOut]

	/*
	Check to see if this is an event or simply a time-out
	*/

	test eax,eax
	jnz >>.PROCESS_EVENTS
		invoke GetLastError
		cmp eax,ERROR_SEM_TIMEOUT
		jne >>.PROCESS_EVENTS
		invoke MessageBox,NULL,"The process has timed out, continue profiling ?","GoP",MB_YESNO
		cmp eax,IDYES
		je <<.WAIT_FOR_EVENT
		invoke TimingMessage,"Process halted"
		jmp >>.STOP_DEBUG

	.PROCESS_EVENTS

	/*
		An event has been triggered. Check to see if it is the application start up
		Since this is a profiler and not a debugger we do not need to set anything up
		at CREATE_PROCESS_DEBUG_EVENT just flag it so the thread knows when the process
		is active, this might come in handy later...
	*/

	.CREATE_PROCESS_DEBUG_EVENT
	cmp D[dbe.dwDebugEventCode],CREATE_PROCESS_DEBUG_EVENT
	jne >.EXCEPTION_DEBUG_EVENT
		invoke TimingMessage,"Process Start"
		jmp >>.CONTINUE_DEBUG

	.EXCEPTION_DEBUG_EVENT

	cmp D[dbe.dwDebugEventCode],EXCEPTION_DEBUG_EVENT
	jne >>.LOAD_DLL_DEBUG_EVENT

		.EXCEPTION_BREAKPOINT
		cmp D[dbe.u.Exception.ExceptionRecord.ExceptionCode],EXCEPTION_BREAKPOINT
		jne >>.UNHANDLED
			// The fActive flag skips the startup breakpoint which is generated by
			// Windows for all processes being debugged. If this is the startup
			// breakpoint just ignore it and continue debugging
			cmp D[fActive],TRUE
			mov D[fActive],TRUE
			jne >>.CONTINUE_DEBUG
			mov D[context.ContextFlags],CONTEXT_CONTROL
			invoke GetThreadContext,[pi.hThread],offset context
			// Obtain the address of the profile arguments from the debuggees stack
			invoke ReadProcessMemory,[pi.hProcess],[context.Esp],offset pProfileInfo,4,offset cbWritten
			// Read the profile name
			invoke ReadProcessMemory,[pi.hProcess],[pProfileInfo],offset ProfileName,28,offset cbWritten
			// Read the profile type
			mov eax,[pProfileInfo]
			add eax,ExceptionArgs.type
			invoke ReadProcessMemory,[pi.hProcess],eax,offset ProfileType,4,offset cbWritten

			// Check to see what kind of breakpoint this is
			cmp D[ProfileType],EXCEPTION_STARTPROFILE
			jne >
			// Add this profile to the stack and display the start EIP and time
			invoke AddProfile,offset ProfileName,[context.Eip]
			jmp >>.EXITBREAKPOINT
			:
			// Remove this profile from the stack and display the end EIP and
			// time as well as the difference
			invoke EndProfile,offset ProfileName,[context.Eip]

			.EXITBREAKPOINT
			// Add 4 bytes to the profilee's ESP, this will remove the profile
			// information pointer from its stack
			mov D[context.ContextFlags],CONTEXT_CONTROL
			Add D[context.Esp],4
			invoke SetThreadContext,[pi.hThread],offset context

			jmp >>.CONTINUE_DEBUG

		// all other exceptions are passed to the system on the first chance
		// on the second chance the profiler terminates the application
		.UNHANDLED
		cmp D[dbe.u.Exception.dwFirstChance],0
		je >
		invoke ContinueDebugEvent,[dbe.dwProcessId],[dbe.dwThreadId],DBG_EXCEPTION_NOT_HANDLED
		jmp <<.WAIT_FOR_EVENT
		:
		invoke MessageBox,NULL,"An unhandled exception has occured","GoP",MB_OK
		jmp >>.STOP_DEBUG

	.LOAD_DLL_DEBUG_EVENT
	cmp D[dbe.dwDebugEventCode],LOAD_DLL_DEBUG_EVENT
	jne >>.EXIT_PROCESS_DEBUG_EVENT
		/*
		I assume we must handle this event if for nothing else than to close
		the handles that are opened in the debug process so we might as well
		display the loaded DLLs in a tab
		*/

		/*
			Can't yet figure out how to obtain a DLL name from a handle
			except using Vista only functions.
		*/
		invoke RtlZeroMemory,offset DllPath,MAX_PATH
		mov D[fni.FileNameLength],MAX_PATH
		invoke GetFileInformationByHandleEx,[dbe.u.LoadDll.hFile],FileNameInfo,offset fni,SIZEOF FILE_NAME_INFO + MAX_PATH
		invoke WideCharToMultiByte,CP_ACP,NULL,offset fni.FileName,-1,offset DllPath,MAX_PATH,NULL,NULL
		invoke PathFindFileName,offset DllPath
		invoke AddLoadedDll,eax,[dbe.u.LoadDll.lpBaseOfDll]
		invoke CloseHandle,[dbe.u.LoadDll.hFile]

		jmp >>.CONTINUE_DEBUG

	.EXIT_PROCESS_DEBUG_EVENT
	cmp D[dbe.dwDebugEventCode],EXIT_PROCESS_DEBUG_EVENT
	jne >>.CONTINUE_DEBUG
	invoke TimingMessage,"Process End"
	/*
		When the process exits the debug thread should close
	*/
	jmp >>.EXIT_DEBUG

	.CONTINUE_DEBUG
	// This will instruct the profiler to continue
	invoke ContinueDebugEvent,[dbe.dwProcessId],[dbe.dwThreadId],DBG_CONTINUE
	jmp <<.WAIT_FOR_EVENT

	.STOP_DEBUG
	// This will instruct the profiler to stop
	// Note that this requires WinXP or greater !!!
	invoke DebugActiveProcessStop,[pi.dwProcessId]
	invoke TerminateProcess,[pi.hProcess],NULL

	.EXIT_DEBUG
	invoke CloseHandle,[pi.hThread]
	invoke CloseHandle,[pi.hProcess]
	.EXITTHREAD
	mov D[fActive],FALSE
	invoke ExitThread,NULL
	RET
ENDF

AddProfile FRAME pName, Address
	uses edi
	// allocate a PROFILE_ITEM structure for this profile
	invoke GlobalAlloc,GMEM_FIXED,SIZEOF PROFILE_ITEM
	mov edi,eax

	// Copy the name to the structure
	mov eax,edi
	add eax,PROFILE_ITEM.Name
	invoke lstrcpyn,eax,[pName],255

	mov eax,[Address]
	mov [edi+PROFILE_ITEM.Address],eax

	// Store the time the profile started
	mov eax,edi
	add eax,PROFILE_ITEM.StartTick
	invoke QueryPerformanceCounter,eax

	// Insert a pointer to the array
	invoke DPA_InsertPtr,[hProfArray],0,edi

	// Add the preliminary item in the listview
	mov eax,edi
	add eax,PROFILE_ITEM.Name
	mov ecx,edi
	add ecx,PROFILE_ITEM.StartTick
	invoke ListviewAddItem,eax,ecx,edi
	RET
ENDF

EndProfile FRAME pName, Address
	uses edi,esi,ebx
	LOCAL LVItem		:LVITEM
	LOCAL szOut[64]		:%CHAR

	invoke lstrcpy,offset szOut,"Invalid entry"
	// Get the current PROFILE_ITEM structures address
	invoke DPA_GetPtr,[hProfArray],0
	test eax,eax
	jz >>.EXIT

	mov edi,eax
	add eax, PROFILE_ITEM.EndTick
	push eax
	invoke QueryPerformanceCounter,eax
	pop edx
	// convert the number to a base ten string
	invoke _ui64toa,[edx],[edx+4],offset szOut,10
	add esp,16
	
	mov eax,[edi+PROFILE_ITEM.idItem]
	mov D[LVItem.iItem],eax

	// Finalize the entry in the listview
	lea eax,szOut
	mov [LVItem.pszText],eax
	mov D[LVItem.iSubItem],3
	mov D[LVItem.mask],LVIF_TEXT
	invoke SendMessage,[hTimingListView],LVM_SETITEM,0,OFFSET LVItem

	invoke wsprintf,offset szOut,"0x%08X",[Address]
	add esp,12
	lea eax,szOut
	mov [LVItem.pszText],eax
	mov D[LVItem.iSubItem],4
	mov D[LVItem.mask],LVIF_TEXT
	invoke SendMessage,[hTimingListView],LVM_SETITEM,0,OFFSET LVItem

	// Calculate elapsed time
	mov esi,[edi+PROFILE_ITEM.EndTick]
	mov ebx,[edi+PROFILE_ITEM.EndTick+4]
	sub esi,[edi+PROFILE_ITEM.StartTick]
	sbb ebx,[edi+PROFILE_ITEM.StartTick+4]

	invoke _ui64toa,esi,ebx,offset szOut,10
	add esp,16
	lea eax,szOut
	mov [LVItem.pszText],eax
	mov D[LVItem.iSubItem],5
	mov D[LVItem.mask],LVIF_TEXT
	invoke SendMessage,[hTimingListView],LVM_SETITEM,0,OFFSET LVItem

	// Remove the last item from the stack
	invoke GlobalFree,edi
	invoke DPA_DeletePtr,[hProfArray],0
	.EXIT
	RET
ENDF

FreeAll FRAME pItem, param

	// This function walks through the DPA and frees the global handles in it
	mov eax,[pItem]
	mov eax,[eax]
	test eax,eax
	jz >
		invoke GlobalFree,eax
	:
	RET
ENDF

SetupDllListView FRAME
	uses edi,esi
	LOCAL LVColumn		:LVCOLUMN

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	push "Dll name"
	pop [LVColumn.pszText]
	mov D[LVColumn.cchTextMax],SIZEOF lvProfileName
	invoke SendMessage,[hDllListView],LVM_INSERTCOLUMN,0,OFFSET LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	push "Load Address"
	pop [LVColumn.pszText]
	mov D[LVColumn.cchTextMax],SIZEOF lvProfileStart
	invoke SendMessage,[hDllListView],LVM_INSERTCOLUMN,1,OFFSET LVColumn

	invoke SendMessage,[hDllListView],LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES

	ret
ENDF

SetupTimingListView FRAME
	uses edi,esi
	LOCAL LVColumn		:LVCOLUMN

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	mov D[LVColumn.pszText],OFFSET lvProfileName
	mov D[LVColumn.cchTextMax],SIZEOF lvProfileName
	invoke SendMessage,[hTimingListView],LVM_INSERTCOLUMN,0,OFFSET LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	mov D[LVColumn.pszText],OFFSET lvProfileStart
	mov D[LVColumn.cchTextMax],SIZEOF lvProfileStart
	invoke SendMessage,[hTimingListView],LVM_INSERTCOLUMN,1,OFFSET LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	mov D[LVColumn.pszText],OFFSET lvStartEIP
	mov D[LVColumn.cchTextMax],SIZEOF lvStartEIP
	invoke SendMessage,[hTimingListView],LVM_INSERTCOLUMN,2,OFFSET LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	mov D[LVColumn.pszText],OFFSET lvProfileEnd
	mov D[LVColumn.cchTextMax],SIZEOF lvProfileEnd
	invoke SendMessage,[hTimingListView],LVM_INSERTCOLUMN,3,OFFSET LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	mov D[LVColumn.pszText],OFFSET lvEndEIP
	mov D[LVColumn.cchTextMax],SIZEOF lvEndEIP
	invoke SendMessage,[hTimingListView],LVM_INSERTCOLUMN,4,OFFSET LVColumn

	mov D[LVColumn.mask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.cx],125
	mov D[LVColumn.pszText],OFFSET lvProfileDiff
	mov D[LVColumn.cchTextMax],SIZEOF lvProfileDiff
	invoke SendMessage,[hTimingListView],LVM_INSERTCOLUMN,5,OFFSET LVColumn

	invoke SendMessage,[hTimingListView],LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES

	ret
ENDF

TimingMessage FRAME pszMessage
	LOCAL LVItem		:LVITEM
	LOCAL szOut[64]		:%CHAR
	LOCAL ItemID		:%DWORD32

	invoke SendMessage,[hTimingListView],LVM_GETITEMCOUNT,0,0
	mov [LVItem.iItem],eax
	mov D[LVItem.mask],LVIF_TEXT
	mov D[LVItem.iSubItem],0
	mov eax,[pszMessage]
	mov [LVItem.pszText],eax
	invoke SendMessage,[hTimingListView],LVM_INSERTITEM,0,OFFSET LVItem

	RET
ENDF

ListviewAddItem FRAME pszName,pTickCount,pProfile
	LOCAL LVItem		:LVITEM
	LOCAL szOut[64]		:%CHAR
	LOCAL ItemID		:%DWORD32

	invoke SendMessage,[hTimingListView],LVM_GETITEMCOUNT,0,0
	mov [ItemID],eax

	mov edx,[pProfile]
	mov [edx],eax

	mov D[LVItem.mask],LVIF_TEXT
	mov D[LVItem.iSubItem],0
	mov eax,[pszName]
	mov [LVItem.pszText],eax

	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	invoke SendMessage,[hTimingListView],LVM_INSERTITEM,0,OFFSET LVItem
	mov [ItemID],eax

	mov eax,[pTickCount]
	invoke _ui64toa,[eax],[eax+4],offset szOut,10
	add esp,16
	lea eax,szOut
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],1
	mov D[LVItem.mask],LVIF_TEXT
	invoke SendMessage,[hTimingListView],LVM_SETITEM,0,OFFSET LVItem

	mov edx,[pProfile]
	invoke wsprintf,offset szOut,"0x%08X",[edx+PROFILE_ITEM.Address]
	add esp,12
	lea eax,szOut
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],2
	mov D[LVItem.mask],LVIF_TEXT
	invoke SendMessage,[hTimingListView],LVM_SETITEM,0,OFFSET LVItem

	mov eax,[ItemID]

	ret

ENDF

AddLoadedDll FRAME pszName, Address
	LOCAL LVItem		:LVITEM
	LOCAL szOut[64]		:%CHAR
	LOCAL ItemID		:%DWORD32

	invoke SendMessage,[hTimingListView],LVM_GETITEMCOUNT,0,0
	mov [ItemID],eax

	mov D[LVItem.mask],LVIF_TEXT
	mov D[LVItem.iSubItem],0
	mov eax,[pszName]
	mov [LVItem.pszText],eax

	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	invoke SendMessage,[hDllListView],LVM_INSERTITEM,0,OFFSET LVItem
	mov [ItemID],eax

	invoke wsprintf,offset szOut,"0x%08X",[Address]
	add esp,12
	lea eax,szOut
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],1
	mov D[LVItem.mask],LVIF_TEXT
	invoke SendMessage,[hDllListView],LVM_SETITEM,0,OFFSET LVItem
	
	RET
ENDF

